import ts from 'typescript';
import { Variant } from './types';
/**
 * Given a list of style variants, select a given one based on input props
 * @internal
 * @param variants list of style variants to select from
 * @param props variant values to select from the list, may include additional props, to tidy up usage upstream
 */
export declare function getOverridesFromVariants<T>(variants: Variant[], props: {
    [key: string]: T;
}): {
    [key: string]: Variant;
};
export declare const buildGetOverridesFromVariants: () => ts.FunctionDeclaration[];
